/* int^WSortedIntSetiwb_j*/

#ifndef ___SortedIntSet
#define ___SortedIntSet

/*--- int^̏W\ ---*/
typedef struct {
	int max;	/* W̗e */
	int num;	/* W̗vf */
	int *set;	/* W{̂̔zi̐擪vfւ̃|C^j*/
} SortedIntSet;

/*--- W̏ ---*/
int Initialize(SortedIntSet *s, int max);

/*--- WsnĂ邩 ---*/
int IsMember(const SortedIntSet *s, int n);

/*--- Ws͖tivfǉłȂԁj ---*/
int IsFull(const SortedIntSet *s);

/*--- Wsnǉ ---*/
void Add(SortedIntSet *s, int n);

/*--- Wsn폜 ---*/
void Remove(SortedIntSet *s, int n);

/*--- Wsi[łő̗vf ---*/
int Capacity(const SortedIntSet *s);

/*--- Ws̗vf ---*/
int Size(const SortedIntSet *s);

/*--- Ws2s1ɑ ---*/
void Assign(SortedIntSet *s1, const SortedIntSet *s2);

/*--- Ws1s2͓ ---*/
int Equal(const SortedIntSet *s1, const SortedIntSet *s2);

/*--- Ws2s3̘aWs1ɑ ---*/
SortedIntSet *Union(SortedIntSet *s1, const SortedIntSet *s2, const SortedIntSet *s3);

/*--- Ws2s3̐ϏWs1ɑ ---*/
SortedIntSet *Intersection(SortedIntSet *s1, const SortedIntSet *s2, const SortedIntSet *s3);

/*--- Ws2s3Ws1ɑ ---*/
SortedIntSet *Difference(SortedIntSet *s1, const SortedIntSet *s2, const SortedIntSet *s3);

/*--- Ws2s3̑Ώۍs1ɑ ---*/
SortedIntSet *SymmetricDifference(SortedIntSet *s1, const SortedIntSet *s2, const SortedIntSet *s3);

/*--- Ws1ɑ΂ďWs2̑Svfǉ ---*/
SortedIntSet *ToUnion(SortedIntSet *s1, const SortedIntSet *s2);

/*--- Ws1Ws2Ɋ܂܂ȂSvf폜 ---*/
SortedIntSet *ToIntersection(SortedIntSet *s1, const SortedIntSet *s2);

/*--- Ws1Ws2Ɋ܂܂Svf폜 ---*/
SortedIntSet *ToDifference(SortedIntSet *s1, const SortedIntSet *s2);

/*--- Ws1s2̕W ---*/
int IsSubset(const SortedIntSet *s1, const SortedIntSet *s2);

/*--- Ws1s2̐^W ---*/
int IsProperSubset(const SortedIntSet *s1, const SortedIntSet *s2);

/*--- Ws̑Svf\ ---*/
void Print(const SortedIntSet *s);

/*--- Ws̑Svf\istj---*/
void PrintLn(const SortedIntSet *s);

/*--- Ws̑Svf폜 ---*/
void Clear(SortedIntSet *s);

/*--- W̌n ---*/
void Terminate(SortedIntSet *s);

#endif
